Admin screen - "New custom field" button does not work if there are no custom fields

2019-08-14 12:13 - Neville Kuyt

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Administration Estimated time: 0.00 hour

Target version:    

Resolution: Fixed Affected version:  

Description

New install of Redmine.

Log in as an administrator.

Go to "administrattion" tab, then select "custom fields".

Click on "New custom field".

Expected: New custom field form shows.

Actual: nothing happens.

Cause: the "New custom field" link includes some JavaScript to figure out which tab is selected; it uses this to figure out the "onclick"

action. When there are no custom fields, there are no tabs, and therefore the JavaScript fails to generate a valid URL for the onclick.

Environment:

Redmine version                4.0.4.devel

Ruby version                   2.3.7-p456 (2018-03-28) [universal.x86_64-darwin18]

Rails version                  5.2.3

Environment                    development

Database adapter               SQLite

Mailer queue                   ActiveJob::QueueAdapters::AsyncAdapter

Mailer delivery                smtp

SCM:

Subversion                     1.10.3

Git                            2.19.0

Filesystem

Redmine plugins:

no plugin installed

Related issues:

Related to Redmine - Patch #31320: Set an appropriate default type in New cus... Closed

Associated revisions

Revision 18372 - 2019-08-17 04:01 - Go MAEDA

Fix that "New custom field" button does not work if there are no custom fields (#31896, #31320).

Patch by Mizuki ISHIKAWA.

History

#1 - 2019-08-14 12:46 - Marius BĂLTEANU

- Status changed from New to Confirmed

Caused by #31320

#2 - 2019-08-14 12:46 - Marius BĂLTEANU

- Related to Patch #31320: Set an appropriate default type in New custom field page depending on the current tab added

#3 - 2019-08-16 02:39 - Mizuki ISHIKAWA

Thank you for sharing this issue.

The changes below should make the "New custom field" link work.
diff --git a/app/views/custom_fields/index.html.erb b/app/views/custom_fields/index.html.erb

index 3f1154dc7..0eecc6014 100644

--- a/app/views/custom_fields/index.html.erb

+++ b/app/views/custom_fields/index.html.erb

@@ -1,5 +1,5 @@

 <div class="contextual">

-<%= link_to_function l(:label_custom_field_new), "location.href = '#{new_custom_field_path}?tab=' + encodeURI

Component($('.tabs a.selected').attr('id').split('tab-').pop())", :class => 'icon icon-add' %>

+<%= link_to_function l(:label_custom_field_new), "location.href = '#{new_custom_field_path}?tab=' + encodeURI

Component(($('.tabs a.selected').attr('id')||'').split('tab-').pop())", :class => 'icon icon-add' %>

 </div>

 <%= title l(:label_custom_field_plural) %>

#4 - 2019-08-16 10:50 - Neville Kuyt

Mizuki ISHIKAWA wrote:

Thank you for sharing this issue.

The changes below should make the "New custom field" link work.

[...]

 Tested - yes, this fixes it. Thank you!

#5 - 2019-08-17 04:02 - Go MAEDA

- Status changed from Confirmed to Closed

- Resolution set to Fixed

- Affected version deleted (4.0.4)

Committed the fix. Thank you all for reporting and fixing this issue.
